;! " Textured 2-peaks mountain "
;? " Scale: "=SML_Scale
;? " Heading [HDG]: "=SML_Heading
;? " (1. Rocky Mountain), (2. Grass Mountain) - Type: "=SML_Type
; By Alessandro Antonini


MACRO _Mnt12P

Local ObjEnd, ObjReturn, Dwg, Pcall, Scall, CrashDet, Exec, TType, TTypeExt

TType = "airpt008"
TTypeExt = "oav"

If (SML_Type == 1)
    TType = "a-obj-3"
    TTypeExt = "r8"
Else
    TType = "airpt008"
    TTypeExt = "oav"
EndIf        

_Area( 0x0B, SML_Lat, SML_Lon, 160 km, ObjEnd )
    PerspectiveCall( Pcall )
    ShadowCall( Scall )
    Goto( ObjEnd )

Pcall:
    Perspective

Scall:
    ReferencePoint( SML_Lat, SML_Lon, ObjReturn, 1, 0 )
    _FS5SCALE = (SML_Scale * 100) / (SML_Scale*SML_Scale)/100
    Rotate( Dwg, 0, 0, SML_Heading )

ObjReturn:
    Return

Dwg:
    PointsList( 1, 10 )
        Point(  -1160,    0,   32     )
        Point(   -680,    0,  680     )
        Point(   -250,    0,  730     )
        Point(   1040,    0,  240     )
        Point(   1240,    0, -390     )
        Point(    720,    0, -820     )
        Point(    -40,    0, -860     )
        Point(   -780,    0, -330     )
        Point(   -390,  370,  100     )
        Point(    380,  440, -100     )
    Call( Exec )
    Return

Exec:
    Texture( TType, TTypeExt )
    TextureSmoothOn

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  1,    8, 139 )
        TexturePt(  2,  130,  28 )
        TexturePt(  9,  213, 178 )

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  2,  51,   34 )
        TexturePt(  3,  181,  28 )
        TexturePt(  9,  144, 200 )

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  3,  164,  25 )
        TexturePt( 10,  214, 233 )
        TexturePt(  9,   48, 199 )

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  3,   23,  11 )
        TexturePt(  4,  202,  86 )
        TexturePt( 10,  103, 208 )

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  4,  170,  29 )
        TexturePt(  5,  252, 215 )
        TexturePt( 10,   86, 176 )

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  5,   54,  50 )
        TexturePt(  6,  210,  94 )
        TexturePt( 10,  118, 229 )

    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  6,  190, 201 )
        TexturePt(  7,   42, 220 )
        TexturePt( 10,  144,  47 )


    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  7,   85, 220 )
        TexturePt(  9,   35,  35 )
        TexturePt( 10,  193,  71 )


    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  8,   31, 152 )
        TexturePt(  9,  181,  50 )
        TexturePt(  7,  217, 229 )


    AdjustTexture
    TexturePolygon( 3 )
        TexturePt(  1,   29,  38 )
        TexturePt(  9,  199, 133 )
        TexturePt(  8,   59, 201 )

    TextureSmoothOff
    Return

ObjEnd:
    ENDMACRO
